[关闭]
@NewWorld 2016-04-10T14:18:25.000000Z 字数 947 阅读 1384

LeetCode:Nim Game

LeetCode


先上题目链接:Nim Game

You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

题目大意就是给你一堆石头,每次可以从中拿出1~3块,两个人轮流拿,拿到最后一块石头的人获胜。现在有 n 块石头,由你先拿,请快速判断你能否获胜。

表示有 n 块石头时的获胜情况(必输/必赢),由于你拿了之后,接着是对方拿,所以得到公式:


由于 ,结合公式可以发现这是一个长度为4的循环,得到这样一个关系:

代码如下:

  1. public class Solution {
  2. public boolean canWinNim(int n) {
  3. boolean result = false;
  4. if (n < 1) {
  5. return false;
  6. }
  7. if ((n%4) != 0) {
  8. result = true;
  9. }
  10. return result;
  11. }
  12. }
添加新批注
在作者公开此批注前,只有你和作者可见。
回复批注